;+
; $LastChangedBy: davin-win $
; $LastChangedDate: 2007-02-07 04:31:07 -0800 (Wed, 07 Feb 2007) $
; $LastChangedRevision: 313 $
; $URL: svn+ssh://thmsvn@ambrosia.ssl.berkeley.edu/repos/ssl_general/trunk/CDF/cdf_load_vars.pro $
;-
function cdf_load_vars,files,varnames=vars,info=info,verbose=verbose,all=all,record=record

vb = keyword_set(verbose) ? verbose : 0

;if not keyword_set(info) then info = cdf_info(files[0],/attributes)
i=0
repeat begin
   info = cdf_info(files[i++],/attributes,verbose=verbose)
endrep until keyword_set(info) or i eq n_elements(files)

if not keyword_set(info) then begin
   if vb ge 2 then print,ptrace(),'Invalid CDF files:', '"'+files+'"'
   return,0
endif

if keyword_set(all) then vars = info.vars.name

for i=0,n_elements(files)-1 do begin
  if file_test(files[i]) eq 0 then begin
     if vb ge 1 then  print,ptrace(),'File not found: ',files[i]
;     message,/info,'No such file: '+files[i]
     continue
  endif
  id = cdf_open(files[i])
  for j=0,n_elements(vars)-1 do begin
    w = (where( strcmp(info.vars.name, vars[j]) , nw))[0]
    if nw ne 0 then begin
       vi = info.vars[w]
; get number of records in this file  numrec = vi.numrec
       q=!quiet & !quiet=1 & cdf_control,id,var=vi.name,get_var_info=vinfo & !quiet=q
       numrec = vinfo.maxrec+1

       if numrec gt 0 then begin

          if n_elements(record) ne 0  then $
               cdf_varget,id,vi.name,value ,/string ,rec_start=record  $
          else $
               cdf_varget,id,vi.name,value ,/string ,rec_count=numrec

          if vi.recvary then begin
             if (vi.ndimen ge 1 and n_elements(record) eq 0) then begin
                transshift = shift(indgen(vi.ndimen+1),1)
                value=reform(transpose(temporary(value),transshift),/overwrite)
             endif else value = reform(value,/overwrite)
             if vb ge 6 then printdat,value,vi.name,/pgmtrace
             if not keyword_set(vi.dataptr) then  vi.dataptr = ptr_new(value,/no_copy)  $
             else  *vi.dataptr = [*vi.dataptr,temporary(value)]
          endif else begin
             if vb ge 6 then printdat,value,vi.name,/pgmtrace
             if not keyword_set(vi.dataptr) then vi.dataptr = ptr_new(value,/no_copy)
          endelse
          info.vars[w] = vi
       endif
    endif else if vb ge 1 then print,ptrace(),vars[j]+' not found!'
  endfor
  cdf_close,id

endfor


return,info
end

