;+
;	Function: THM_DATA_CALIBRATED
;
;	Purpose:  Determine whether the data stored in a particular TPLOT variable has already been calibrated by examining the contents of it's DLIMIT structure.
;
;	Calling Sequence:
;		tplot_var = 'tha_eff'
;		get_data, tplot_var, data=d, limit=l, dlimit=dl
;		if thm_data_calibrated( dl) then return
;
;	Arguements:
;		DL, Anonymous STRUCT.
;
;	Notes:
;		None.
;
; $LastChangedBy: kenb-mac $
; $LastChangedDate: 2007-02-08 10:02:45 -0800 (Thu, 08 Feb 2007) $
; $LastChangedRevision: 329 $
; $URL $
;-

function thm_data_calibrated, dl

res = 0b
if (size( dl, /type) eq 8) then begin
	tags = tag_names( dl)
	idx = where( strcmp( strlowcase( tags), 'data_type'), icnt)
	if icnt gt 0 then begin
		if dl.(idx[ 0L]) eq 'calibrated' then res = 1b
	endif
endif

return, res
end
