function thm_file_cleanup,filespec,print=print, $
    sort_atime=sort_atime,sort_mtime=sort_mtime,sort_size=sort_size,reverse=reverse

thm_init

if not keyword_set(filespec) then filespec = '*.cdf'


; remove empty directories:
dirs = file_search(!themis.local_data_dir,'*',/test_directory)
file_delete,reverse(dirs),/quiet,/verbose

files = file_search(!themis.local_data_dir,filespec,/test_regular)


info = file_info(files)
;print_struct,info

srt = indgen(n_elements(info))
if keyword_set(sort_atime) then srt = sort(info.atime)
if keyword_set(sort_mtime) then srt = sort(info.mtime)
if keyword_set(sort_size) then srt = sort(info.size)
if keyword_set(reverse) then srt = reverse(srt)
info = info[srt]

if keyword_set(print) then begin
  fmt='(a,"  ",a,"  ",f7.1,"    ",a)'

  for i=0,n_elements(info)-1 do $
    print,time_string(info[i].atime),time_string(info[i].mtime),info[i].size/1024./1024.,info[i].name,format=fmt
endif

return,files

end
