;+
;	Batch File: THM_CRIB_EFI
;
;	Purpose:  Demonstrate the loading, calibration, and plotting
;		of THEMIS EFI data.
;
;	Calling Sequence:
;	.run thm_crib_fbk, or using cut-and-paste.
;
;	Arguements:
;   None.
;
;	Notes:
;	None.
;
; $LastChangedBy: kenb-win2000 $
; $LastChangedDate: 2007-02-12 21:01:54 -0800 (Mon, 12 Feb 2007) $
; $LastChangedRevision: 392 $
; $URL $
;-

; EFI waveform data example.
tplot_title = 'THEMIS EFI Waveform Examples'
tplot_options, 'title', tplot_title
tplot_options, 'xmargin', [ 15, 10]
tplot_options, 'ymargin', [ 5, 5]

timespan, '2006-08-03', 1.0, /day
thm_load_efi, /get_support_data
loadct2, 39

options, 'th?_v??', 'colors', [ 1, 2, 3, 4, 5, 6]
options, 'th?_v??', 'labels', [ 'V1', 'V2', 'V3', 'V4', 'V5', 'V6']
options, 'th?_v??', 'labflag', 1

options, 'th?_e??', 'colors', [ 2, 4, 6]
options, 'th?_e??', 'labels', [ 'e12', 'e34', 'e56']
options, 'th?_e??', 'labflag', 1

tplot, [ 'tha_vaf', 'tha_eff']
tlimit, '2006-08-03/20:50:00', '2006-08-03/21:15:00'
stop

thm_cal_efi, /verbose

tplot, [ 'tha_vaf_raw', 'tha_vaf', 'tha_eff_raw', 'tha_eff']
stop

tplot, [ 'tha_vap_raw', 'tha_vap', 'tha_efp_raw', 'tha_efp']

; something wrong with EFW data on 2006-08-03, so skip this for demo.
;tplot, [ 'tha_vaw_raw', 'tha_vaw', 'tha_efw_raw', 'tha_efw']

end
