;+
;pro thm_crib_mom
; This is an example crib sheet that will load MOMent data.
; Open this file in a text editor and then use copy and paste to copy
; selected lines into an idl window. Or alternatively compile and run
; using the command:
; .RUN THM_CRIB_MOM
;-

!quiet=1                             ;  Turn off annoying screen messages.
wset,0
pos=ptrace(option=1)                 ;  Set program trace to display line numbers.
del_data,'*'                   &   print,ptrace(),'       Deleted all TPLOT data'
erase                          &   print,ptrace(),'       Cleared the screen.'
timespan,'6-11-30',1,/days     &   print,ptrace(),'       Defined the time span of interest.
thm_load_mom,probe='a b c'     &   print,ptrace(),'       (Down)loaded MOMent Data, from probes a b and c'
print
print,'Defined TPLOT Variables;'
tplot_names ,/time                   ;  Display all stored variables
print

print,ptrace(),'             Note that 3 probes were loaded each with 1 day of data.'
print,ptrace(),'             However, there is no data from PROBE "b" so it does not appear.
print,ptrace(),'             All files are downloaded automatically if not found.'
stop


wshow,0                                ; Raise window
tplot_options, 'title', 'THEMIS MOM Examples'
tplot,"tha_mom*"                   ; tplot accepts wildcard characters
print,ptrace(),'             Plotted all TPLOT variables that match "tha_mom" '
stop


wshow,0
tr =  ['2006-11-30/20:36:30', '2006-11-30/21:55:50']   ; Define a time range
timebar,tr                               ; Display it
print,ptrace(),'             Define and Display a time range'
stop



tlimit,tr                               ; Zoom into the time range
print,ptrace(),'             Zoom into the defined time range'
stop



thm_cal_mom       ;          Moment calibration routine
print,'Defined TPLOT Variables;'
tplot_names               ;  Display all stored variables
print,ptrace(),'             Run MOMent calibration routine'
print,ptrace(),'             This routine automatically downloads the latest calibration file'
stop



tplot,'th?_eim_dens th?_eim_vel'
print,ptrace(),'             Plot Esa Ion Mom DENSity and Esa Ion Mom VELocity of all spacecraft
print,ptrace(),'             This routine automatically downloads the latest calibration file'
stop





end
