;+
;pro thm_crib_sst
; This is an example crib sheet that will load Solid State Telescope data.
; Open this file in a text editor and then use copy and paste to copy
; selected lines into an idl window. Or alternatively compile and run
; using the command:
; .RUN THM_CRIB_SST
;-


!quiet=1                             ;  Turn off annoying screen messages.
wset,0
pos=ptrace(option=1)                 ;  Set program trace to display line numbers.
del_data,'*'                   &   print,ptrace(),'       Deleted all TPLOT data'
erase                          &   print,ptrace(),'       Cleared the screen.'
timespan,'6-11-30',1,/days     &   print,ptrace(),'       Defined the time span of interest.
thm_load_sst,probe='a'         &   print,ptrace(),'       (Down)loaded SST Data
print
print,'Defined TPLOT Variables;'
tplot_names ,/time                   ;  Display all stored variables
print

stop


wshow,0                                ; Raise window
tplot_options, 'title', 'THEMIS SST Examples'
options, 'tha_sif_064', spec = 0      ; turn off spectrogram plot, because not yet implemented
                                      ; for multi-dimension data.
tplot,'tha_sif_064'                   ;
print,ptrace(),'             Plotted all tha_sst_064 data as a multi-line plot '
stop

tlimit

end
