;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;
; Procedure de lecture d'un fichier cowave.resu
; test auusi la bibli r_calilib.pro
;
; Patrick Robert, CETP, Septembre 2000
;                  revu Janvier   2001
;                  revu Mars      2001
;                  revu Aout      2002
;
; *** To be updated to get time with 0.1 microsec accuraccy, in
;     a Julian second variable *****
;
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

  PRO readwave

  PRINT
  PRINT, '------------------------------------------------------'
  PRINT, 'PRO readwave: relecture du fichier cowave.resu
  PRINT, '------------------------------------------------------'
  PRINT

; ======================================================================
; lecture des donnees,  traitement et visualisation de chaque sequence
; ======================================================================

; ouverture du fichier de donnees type cowave.resu

  DataFile = 'cowave.resu'

  r_open_cowave, DataFile
 
  r_head_cowave, idset,fultit,projet,experi,sid,isat,fnat,nbp, $
                          fdet,nlis,fc,f1ulf,f2ulf,nbpan,nbseq, $
                          bitr,fe,fs,srasc,sdec
  
; for each window, we get time and B field

  FOR iseq=1,nbseq DO $
  r_seq_cowave, nbpan,Jul,iday,imon,iyear,ih1,im1,is1,ims1,iano,$
                         nbp,titpan,dtpan,ncpan,nbppan,dataulf,nbpt

  r_eof_cowave

  PRINT, 'readwave.pro: Normal Ending'
  PRINT, '---------------------------'

  END
;
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;
; Modules permettant la lecture des fichiers au format cowave.resu
; Le fichier est lu avec le file code 1.
;
; Patrick Robert, CETP, Septembre 2000, revu  Mai 2001
;                                       revu Aout 2002
;
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;
  PRO r_open_cowave, DataFile

; ======================================================================
; procedure r_open_cowave: ouverure du fichier format cowave.resu
;
; P. Robert, CETP, Septembre 2000, revu Janvier/Mars 2001
; ======================================================================

  PRINT, 'Name of Data File=', DataFile
  PRINT, 'Opening cowave.resu formatted file with code 1'

  OPENR, 1, DataFile, ERROR=ierr

  IF(ierr NE 0) THEN BEGIN
      PRINT,'***/ NO FILE ',DataFile
      STOP,'R_OPEN_COWAVE:ERR-NO DATA FILE                         /***'
;                PRINT, '*** r_open_cowave:  pas de fichier ', DataFile
;                PRINT, '    arret brutal, pas de .ps'
;                STOP,  'r_open_cowave: pas de fichier de donne'
                ENDIF

  RETURN
  END

;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

  PRO r_head_cowave, idset,fultit,projet,experi,sid,isat,fnat,nbp, $
                     fdet,nlis,fc,f1ulf,f2ulf,nbpan,nbseq, bitr,fe,fs, $
                     srasc,sdec

; ======================================================================
; procedure r_head_cowave: lecture du header d'un fic. cowave.resu
;
; P. Robert, CETP, Septembre 2000, revu Janvier/Mars 2001
; ======================================================================

  PRINT, 'Reading header of cowave.resu'
  PRINT, ' '
 
; lecture de l'entete du fichier cowave.resu
; ------------------------------------------
 
  bid   =' '
  tstart=' '
  tend  =' '
  ttrait=' '
  fultit=' '
  projet=' '
  experi=' '
  sid   =' '
  fnat  =' '
  dfrom =' '
  ddcal =' '
  inpar =' '
  bitr  =' '
  texte =' '
  iselpa=INTARR(5)
  nbp=2L
  nlis=0L

; test sur la 1ere ligne du fichier

  READF, 1, FORMAT='(a)', tstart
  IF(tstart NE 'START OF FILE HEADER') THEN BEGIN
      PRINT,'***/ FIRST LINE OF FILE'
      PRINT,'***/ ',tstart
      STOP,'R_HEAD_COWAVE:ERR-FILE IS NOT A COWAVE.RESU FILE       /***'
;                       PRINT, ' '
;                       PRINT, '1st line of File='
;                       PRINT, tstart
;                       PRINT, 'File is not a cowave.resu file'
;                       PRINT, 'Program aborted, no .ps provided'
;                       STOP, 'premature ending'
                       ENDIF

; saut des commentaires

  WHILE (bid NE 'END COMMENTS') DO READF, 1, bid

; lecture des parametres d'entete

  READF, 1, ttrait
  READF, 1, bid
  READF, 1, idset
  READF, 1, bid
  READF, 1, FORMAT='(a)', fultit
  READF, 1, bid
  READF, 1, FORMAT='(a)', projet
  READF, 1, bid
  READF, 1, FORMAT='(a)', experi
  READF, 1, bid
  READF, 1, FORMAT='(a)', sid
  READF, 1, bid
  READF, 1, isat
  READF, 1, bid
  READF, 1, FORMAT='(a)', fnat
  READF, 1, bid
  READF, 1, FORMAT='(a)', dfrom
  READF, 1, bid
  READF, 1, FORMAT='(a)', ddcal
  READF, 1, bid
  READF, 1, FORMAT='(a)', inpar

  READF, 1, bid
  READF, 1, nbp
  READF, 1, bid
  READF, 1, fdet
  READF, 1, bid
  READF, 1, nlis
  READF, 1, bid
  READF, 1, fc
  READF, 1, bid
  READF, 1, f1ulf, f2ulf
  READF, 1, bid
  READF, 1, iselpa

  READF, 1, bid
  READF, 1, nbpan
  READF, 1, bid
  READF, 1, nbseq
  READF, 1, bid
  READF, 1, FORMAT='(a)', bitr
  READF, 1, bid
  READF, 1, fe
  READF, 1, bid
  READF, 1, fs
  READF, 1, bid
  READF, 1, srasc, sdec
  READF, 1, tend

  PRINT, tstart
  PRINT, 'Data Set #: ',idset
  PRINT, 'Full Title: ',fultit
  PRINT, 'Project   : ',projet
  PRINT, 'Experiment: ',experi
  PRINT, 'S/C ID    : ',sid
  PRINT, 'S/C #     : ',isat
  PRINT, 'Field Nat.: ',fnat
  PRINT, 'Data from : ',dfrom
  PRINT, 'nbp       :',nbp  
  PRINT, 'Frequencies: ', fc,f1ulf,f2ulf
  PRINT, 'nbpan   : ',nbpan
  PRINT, 'nbseq   : ',nbseq
  PRINT, 'Bitrate : ',bitr
  PRINT, 'Samp. f.: ',fe
  PRINT, 'Spin  f.: ',fs
  PRINT, 'sra,sdec: ',srasc,sdec
  PRINT, tend


  RETURN
  END

;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

  PRO r_seq_cowave, nbpan,Jul,iday,imon,iyear,ih1,im1,is1,ims1,iano,$
                       nbp,titpan,dtpan,ncpan,nbppan,dataulf,nbpt

; ======================================================================
; procedure r_seq_cowave : lecture d'une sequence de cowave.resu
;                          dataulf(nbpan,3,nbpt)
;
; P. Robert, CETP, Septembre 2000, revu Janvier/Mars 2001
;                                  revu sepr 2002 pour seq incomplete
; ======================================================================

 
; mise a zero de tous les parametres

  titpan= REPLICATE(' ',nbpan)
  dtpan=  REPLICATE(0. ,nbpan)
  ncpan=  REPLICATE(0  ,nbpan)
  nbppan= REPLICATE(0L ,nbpan)

; *** on suppose que tous les pannels ont 3 courbes de nbp points

  dataulf= REPLICATE(0.,nbpan,3,nbp)

  bid   =' '
  tstart=' '
  ttrait=' '
  texte =' '

  nbpt=0L

; lecture d'une sequence
; ======================

  IF(EOF(1)) THEN BEGIN
             PRINT, 'EOF of cowave.resu has already been encontered'
             RETURN
             ENDIF

  READF, 1, ttrait
  PRINT, ttrait

  IF(ttrait EQ 'END OF FILE' ) THEN BEGIN
                               PRINT, 'EOF REACHED on cowave.resu file'
                               PRINT, 'No more sequency, data set to zero'
                               RETURN
                               ENDIF
  READF, 1, tstart
  READF, 1, bid
  READF, 1, Jul,iday,imon,iyear
  READF, 1, bid
  READF, 1, ih1,im1,is1,ims1, imm1
  READF, 1, bid
  READF, 1, iano

  PRINT, tstart
  PRINT, 'date:', Jul,iday,imon,iyear,iano
  PRINT, 'Time:', ih1,im1,is1,ims1, imm1

; boucle sur les pannels
; ----------------------
 
  FOR ipan= 0,nbpan-1 DO BEGIN

  READF, 1, ttrait
  READF, 1, tstart
  READF, 1, bid
  READF, 1, istep
  READF, 1, bid
  READF, 1, FORMAT='(a)', texte
  READF, 1, bid
  READF, 1, dt
  READF, 1, bid
  READF, 1, nc
  READF, 1, bid
  READF, 1, nbpt

  titpan(ipan)=texte
  dtpan(ipan)=dt
  ncpan(ipan)=nc
  nbppan(ipan)=nbpt

  PRINT, tstart
  PRINT, titpan(ipan)
; PRINT, 'dt,ncp,nbp=',dtpan(ipan),ncpan(ipan),nbppan(ipan)

; *** on a suppose que toutes les courbes de chaque pannel avait nbp pts

  IF(nbpt NE nbp) THEN BEGIN
      PRINT,'***/ NBPT(=',nbpt,') NE NBP (=',nbp,')'
      STOP,'R_SEQ_COWAVE :ERR-NBPT NE NBP                          /***'
;                  PRINT, 'nbpt NE nbp', nbpt,nbp
;                  STOP
                  ENDIF

; *** on a suppose que tous les pannels avait 3 courbes

  IF(ncpan(ipan) NE 3) THEN BEGIN
      PRINT,'***/ IPAN=',ipan
      PRINT,'***/ NCPAN(IPAN)=',ncpan(ipan),' SHOULD BE 3'
      STOP,'R_SEQ_COWAVE :ERR-NCPAN(IPAN) SHOULD BE 3              /***'
;                       PRINT, 'ipan=',ipan
;                       PRINT, 'ncpan(ipan)=',ncpan(ipan)
;                       PRINT, 'ncpan(ipan) must be =3'
;                       PRINT, 'Visualisation aborted, no .ps provided'
;                       STOP, ncpan(ipan)
                       ENDIF

  data0= FLTARR(3,nbppan(ipan))
  READF, 1, bid
  READF, 1, data0
  READF, 1, bid
; PRINT, bid
  dataulf(ipan,*,*)= data0

; fin de boucle sur les pannels

  ENDFOR

  RETURN
  END

;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

  PRO r_eof_cowave

; ======================================================================
; procedure r_eof_cowave : lecture de l'eof du fichier cowave.resu
;
; P. Robert, CETP, Septembre 2000, revu Janvier/Mars 2001
; ======================================================================


; lecture de l'eof et cloture du fichier de donnees


  IF(EOF(1)) THEN BEGIN
             PRINT, 'EOF of cowave.resu has already been encontered'
             PRINT, 'closing LUN 1'
             CLOSE, 1
             RETURN
             ENDIF

  texte= ' '
  READF, 1, FORMAT='(a)', texte
  PRINT, '----------------------------------------------------------'+ $
         '--------------'
  PRINT, 'reading eof of cowave.resu formatted file'
  PRINT, texte
  PRINT, 'closing LUN 1'
  CLOSE, 1

  RETURN
  END

;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
