; XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;
; Write header (metadata) of a RFF file.
;
; P. Robert, CETP, November 2006
;
; XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

PRO thm_scmwf_wrff_header, unit,filname,satname,satnum,mode, $
                                ind_data_for,subtitle,nbvec

; write header

u=unit
fa='(2a)'
fi='(a,i7)'
timcre=SYSTIME(1)
credate=Julsec_to_isodatim(timcre,3)

PRINTF,u,FORMAT=fa,'START ROPROC_FORMAT_FILE'
PRINTF,u,FORMAT=fa,'# ======================================================================'
PRINTF,u,FORMAT=fa,'# The Roproc_Format_File is a general format used mainly for data from'
PRINTF,u,FORMAT=fa,'# spatial missions (magnetometer, waveform units, S/C trajectory ...).'
PRINTF,u,FORMAT=fa,'# For readability, all lines begining with character # are commnents,'
PRINTF,u,FORMAT=fa,'# empty or blank lines are ignored. Others lines are keywords,'
PRINTF,u,FORMAT=fa,'# parameters, variables or data.'
PRINTF,u,FORMAT=fa,'# This file contents MetaData (description of the data), Constant Data'
PRINTF,u,FORMAT=fa,'# (one value per file, or more, but in limited number) and indexed data
PRINTF,u,FORMAT=fa,'# (data versus time or other INDEX).'
PRINTF,u,FORMAT=fa,'# Any group of data begins with a "START" keyword, and stop by a "END".'
PRINTF,u,FORMAT=fa,'# MetaData are given as parameters series (one value per parameter).'
PRINTF,u,FORMAT=fa,'# Data are described by Metadata parameters.'
PRINTF,u,FORMAT=fa,'# Examples of different files are given in the document:'
PRINTF,u,FORMAT=fa,'# "Roproc_Format_File Description", P. Robert, CETP, October 2004.'
PRINTF,u,FORMAT=fa,'#  '
PRINTF,u,FORMAT=fa,'# Author: P. Robert, CNRS/CETP'
PRINTF,u,FORMAT=fa,'# V 1.0, 1996-2000    (for archive of old mission data)'
PRINTF,u,FORMAT=fa,'# V 1.1, October 2001 (for CLUSTER/STAFF-SC NBR & HBR wave data)'
PRINTF,u,FORMAT=fa,'# V 1.2, January 2002 (for GEOS wave data)'
PRINTF,u,FORMAT=fa,'# V 1.3, August  2003 (for CUSP and any kind of wave data)'
PRINTF,u,FORMAT=fa,'# V 1.4, January 2003 (for general titles management)'
PRINTF,u,FORMAT=fa,'# V 2.0, March   2004 (for compatibility with Roproc Vector format)'
PRINTF,u,FORMAT=fa,'# V 2.1, May     2004 (to be coherent with Cluster Exchange Format)'
PRINTF,u,FORMAT=fa,'# Any comment or suggestion: Patrick.Robert@cetp.ipsl.fr'
PRINTF,u,FORMAT=fa,'# ======================================================================'
PRINTF,u,FORMAT=fa,''
PRINTF,u,FORMAT=fa,'START METADATA'
PRINTF,u,FORMAT=fa,'# ----------------------------------------------------------------------'
PRINTF,u,FORMAT=fa,'# two metadata categories: Mandatory Parameters and Optional Parameters'
PRINTF,u,FORMAT=fa,'# ----------------------------------------------------------------------'
PRINTF,u,FORMAT=fa,''
PRINTF,u,FORMAT=fa,'START MANDATORY_PARAMETERS'
PRINTF,u,FORMAT=fa,''
PRINTF,u,FORMAT=fa,'PAR FILE_NAME                 (STR): ', filname
PRINTF,u,FORMAT=fa,'PAR FILE_CLASS                (STR): VecTime'
PRINTF,u,FORMAT=fa,'PAR FILE_FORMAT_VERSION       (STR): Roproc_Format_File V 2.1'
PRINTF,u,FORMAT=fa,'PAR FILE_CREATION_DATE        (STR): ', credate
PRINTF,u,FORMAT=fa,'
PRINTF,u,FORMAT=fa,'PAR MISSION_NAME              (STR): THEMIS'
PRINTF,u,FORMAT=fa,'PAR OBSERVATORY_NAME          (STR): ',satname
PRINTF,u,FORMAT=fi,'PAR OBSERVATORY_NUMBER        (INT): ',satnum
PRINTF,u,FORMAT=fa,'PAR EXPERIMENT_NAME           (STR): SCM'
PRINTF,u,FORMAT=fa,'PAR EXPERIMENT_MODE           (STR): ',mode
PRINTF,u,FORMAT=fa,'PAR INSTRUMENT_TYPE           (STR): Search Coils'
PRINTF,u,FORMAT=fa,'PAR MEASUREMENT_TYPE          (STR): Magnetic field waveform'
PRINTF,u,FORMAT=fa,'
PRINTF,u,FORMAT=fa,'PAR DATA_LABEL                (STR): B'
PRINTF,u,FORMAT=fa,'PAR DATA_FORM                 (STR): Vector'
PRINTF,u,FORMAT=fi,'PAR DATA_DIMENSION            (INT): ',3
PRINTF,u,FORMAT=fa,'PAR DATA_TYPE                 (STR): INT'
PRINTF,u,FORMAT=fa,'PAR DATA_REPRESENTATION       (STR): xyz Cartesian'
PRINTF,u,FORMAT=fa,'PAR DATA_COORDINATE_SYSTEM    (STR): SCS'
PRINTF,u,FORMAT=fa,'PAR DATA_UNITS                (STR): Volt'
PRINTF,u,FORMAT=fa,'PAR DATA_FILL_VALUE           (FLT): -0.1000000E-19'
PRINTF,u,FORMAT=fa,''
PRINTF,u,FORMAT=fa,'PAR INDEX_LABEL               (STR): Time'
PRINTF,u,FORMAT=fa,'PAR INDEX_FORM                (STR): Scalar'
PRINTF,u,FORMAT=fi,'PAR INDEX_DIMENSION           (INT): ',1
PRINTF,u,FORMAT=fa,'PAR INDEX_TYPE                (STR): STR'
PRINTF,u,FORMAT=fa,'PAR INDEX_UNITS               (STR): ISO_TIME Date/Time epoch'
PRINTF,u,FORMAT=fa,'PAR INDEX_PROPERTIES          (STR): Regularly Spaced'
PRINTF,u,FORMAT=fa,'PAR INDEX_EXTENSION           (STR): TMrate Sphase'
PRINTF,u,FORMAT=fa,'PAR INDEX_EXTENSION_FMT       (STR): (i4,1x,f10.6)'
PRINTF,u,FORMAT=fa,'
PRINTF,u,FORMAT=fa,'PAR INDEXED_DATA_FORMAT       (STR): ',ind_data_for
PRINTF,u,FORMAT=fi,'PAR INDEXED_DATA_NUMBER       (INT): ',nbvec
PRINTF,u,FORMAT=fa,'END MANDATORY_PARAMETERS'
PRINTF,u,FORMAT=fa,''
PRINTF,u,FORMAT=fa,'START OPTIONAL_PARAMETERS'
PRINTF,u,FORMAT=fa,'PAR SUB_TITLE                 (STR): ',subtitle
PRINTF,u,FORMAT=fa,'PAR DISCIPLINE_NAME           (STR): Magnetospheric Study
PRINTF,u,FORMAT=fa,'PAR EXPERIMENT_PI_NAME        (STR): Vassilis Angelopoulos <vassilis@ssl.berkeley.edu>'
PRINTF,u,FORMAT=fa,''
PRINTF,u,FORMAT=fa,'PAR MISSION_DESCRIPTION       (TXT):'
PRINTF,u,FORMAT=fa,'{Themis is a set of 5 Spacecraft, launched in February 2007.}'
PRINTF,u,FORMAT=fa,''
PRINTF,u,FORMAT=fa,'PAR EXPERIMENT_DESCRIPTION    (TXT):'
PRINTF,u,FORMAT=fa,'{The Seach Coils experiment (SCM) measure the 3 components'
PRINTF,u,FORMAT=fa,'of the AC magnetic field vector in several frequency ranges:'
PRINTF,u,FORMAT=fa,'according mode and TM rate}'
PRINTF,u,FORMAT=fa,''
PRINTF,u,FORMAT=fa,'PAR DATA_DESCRIPTION          (TXT):'
PRINTF,u,FORMAT=fa,'{This file contains "vector" DATA_FORM which are indexed by the time.'
PRINTF,u,FORMAT=fa,'So this is a temporal series of data blocks. Each block begin with the'
PRINTF,u,FORMAT=fa,'INDEX value, (ISO epoch) the rest of the block is a series of values,'
PRINTF,u,FORMAT=fa,'corresponding to the number of component of the data vector. A data'
PRINTF,u,FORMAT=fa,'block can be written on a single line, or record, or group of lines,'
PRINTF,u,FORMAT=fa,'according the INDEXED_DATA_FORMAT descriptor.}'
PRINTF,u,FORMAT=fa,''
PRINTF,u,FORMAT=fa,'PAR INDEX_DESCRIPTION         (TXT):'
PRINTF,u,FORMAT=fa,'{Time is given in ISO format, accepting any digits for second field as'
PRINTF,u,FORMAT=fa,'"2001-02-18T19:16:17.550934Z"; "T" and "Z" separators are required.}'
PRINTF,u,FORMAT=fa,''
PRINTF,u,FORMAT=fa,'END OPTIONAL_PARAMETERS'
PRINTF,u,FORMAT=fa,'END METADATA'
PRINTF,u,FORMAT=fa,''
PRINTF,u,FORMAT=fa,'START DATA'
PRINTF,u,FORMAT=fa,'# ----------------------------------------------------------------------'
PRINTF,u,FORMAT=fa,'# two categories: Constant data (one value per file), and Indexed data'
PRINTF,u,FORMAT=fa,'# (data versus time or other INDEX'
PRINTF,u,FORMAT=fa,'# ----------------------------------------------------------------------'
PRINTF,u,FORMAT=fa,''
PRINTF,u,FORMAT=fa,'START CONSTANT_DATA'
PRINTF,u,FORMAT=fa,''

  END
; XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
